import pandas as pd
from glob import glob

def run(_, set_path):
    detail_path = glob("data_output/detail_Cancer_Phenotype_*.txt")
    data_set = pd.DataFrame()
    for detail_file in detail_path:
        data = pd.read_csv(detail_file)
        data_set = pd.concat(
            [data_set, data[["Set", "LncRNA", "Sub_Class", "Class"]]], ignore_index=True
        )
    data_set = data_set.groupby(["Set", "Sub_Class", "Class"]).agg(
        {"LncRNA": lambda x: ",".join(set(x.astype(str)))}
    )
    data_set.to_csv(set_path[0])


run(snakemake.input, snakemake.output)