import pandas as pd

def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## 20_mammals ##
    # 20_mammals
    print("-----------20_mammals------------")
    data = pd.read_csv(data_path[0])
    data = data[data["Sub_Class"]=="20_mammals"]
    data = data[["Set","LncRNA","D1_100way_exons","D2_20way_exons","D3_7way_exons","D4_100way_promoters","D5_20way_promoters","D6_7way_promoters"]]
    data.columns = ["Set","LncRNA","D1_100way_exons","D2_20way_exons","D3_7way_exons","D4_100way_promoters","D5_20way_promoters","D6_7way_promoters"]
    data = lnc_filter(data)
    data["Sub_Class"] = "20_mammals"
    data["Class"] = "Conservation"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
