import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## Lnc2Cancer3.0 ##
    # Lnc2Cancer3.0
    print("------------Lnc2Cancer3.0------------")
    data = pd.read_excel(data_path[0])
    data = data[["Drug", "name", "cancer type", "function description", "methods", "sample","regulated","pubmed id"]]
    data = data.astype(str).query("Drug!='0' and Drug!='1'")
    data.columns = [
        "Set",
        "LncRNA",
        "D1_Cancer_type",
        "D2_Function_description",
        "D3_Methods",
        "D4_Sample",
        "D5_Regulated",
        "D6_Pubmed",
    ]
    data = lnc_filter(data)
    data["Sub_Class"] = "Lnc2Cancer3.0"
    data["Class"] = "Drug"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
