import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## Lnc2Cancer2.0 ##
    # Lnc2Cancer2.0
    print("------------Lnc2Cancer2.0------------")
    data = pd.read_csv(data_path[0])
    data = data[
        [
            "Set",
            "LncRNA",
            "D1_cancer_type",
            "D2_ICD_0_3",
            "D4_methods",
            "D5_sample",
            "D6_regulated",
            "D7_pubmed_id",
        ]
    ]
    data.columns = [
        "Set",
        "LncRNA",
        "D1_Cancer_type",
        "D2_ICD_0_3",
        "D3_Methods",
        "D4_Sample",
        "D5_Regulated",
        "D6_Pubmed",
    ]
    data = lnc_filter(data)
    data = data[data.Set != '1']
    data["Sub_Class"] = "Lnc2Cancer2.0"
    data["Class"] = "Drug"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
