import pandas as pd

def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------",data.shape)
    data = data[data.LncRNA.apply(lambda x:x in lncrans)]
    print("---------------Shape: ---------------",data.shape)
    return data

def expand_row(data,col,split=","):
    r = data[col].str.split(split,expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col],axis=1).join(r)
    return data

def run(data_path, detail_path):
    ## DeepBASE3.0 ##
    # DeepBASE3.0
    print("-----------DeepBASE3.0------------")
    data = pd.concat([pd.read_csv(file,sep="\t") for file in data_path],ignore_index=True)
    r = data.iloc[:,4:]
    data = data.iloc[:,:4]
    r = r.stack().reset_index(level=1)
    r.columns = ["Set","Score"]
    r = r[r.Score>0]
    data = data.join(r)
    data = data[["Set","V3"]]
    data.columns = ["Set","LncRNA"]
    data["LncRNA"] = data["LncRNA"].apply(lambda x:"-".join(x.split("-")[:-1]))
    data = lnc_filter(data)
    data["Sub_Class"] = "DeepBASE3.0"
    data["Class"] = "Exosome"
    data.to_csv(detail_path[0], index=False)

run(snakemake.input, snakemake.output)
