import pandas as pd


def lnc_filter(data):
    data = data.dropna().drop_duplicates()
    lncrans = pd.read_csv("data/LncSEA+NONCODE+GENCODE.lnc.txt")
    lncrans = set(lncrans["LncRNA"])
    print("---------------Shape: ---------------", data.shape)
    data = data[data.LncRNA.apply(lambda x: x in lncrans)]
    print("---------------Shape: ---------------", data.shape)
    return data


def expand_row(data, col, split=","):
    r = data[col].str.split(split, expand=True)
    r = r.stack().reset_index(level=1, drop=True).dropna().rename(col)
    data = data.drop([col], axis=1).join(r)
    return data


def run(data_path, detail_path):
    ## TCGA ##
    # TCGA
    print("------------TCGA------------")
    data = pd.read_csv(data_path[0])
    data = data[
        [
            "Set",
            "LncRNA",
            "D1_coef",
            "D2_exp_coef_HR",
            "D3_se_coef",
            "D4_Z_coef_se",
            "D5_Pr_Z_pval",
            "D6_lower_95",
            "D7_upper_95",
            "D8_Likelihood_ratio_test",
            "D9_Wald_test",
            "D10_Log_rank_test",
        ]
    ]
    data = lnc_filter(data)
    data["Sub_Class"] = "TCGA"
    data["Class"] = "Survival"
    data.to_csv(detail_path[0], index=False)


run(snakemake.input, snakemake.output)
