run <- function(data_path,  out_path) {
    data <- read.csv(data_path)
    class <- unique(data$Class)
    print(class)
    subclass_all <- unique(data$Sub_Class)
    print(subclass_all)
    onlist <- lapply(subclass_all,  (function(subclass) {
      subclass_data <- data[which(data$Sub_Class == subclass), ]
      r <- lapply(as.list(subclass_data$LncRNA),  (function(x) {
        r_item <- list()
        r_item$lnc <- unlist(strsplit(as.character(x), ","))
        r_item$length <- length(r_item$lnc)
        r_item
      }))
      names(r) <- unlist(subclass_data$Set)
      r
    }))
    names(onlist) <- paste0(class, "-", subclass_all)
    save(onlist, file = out_path)
}

run(snakemake@input[[1]],  snakemake@output[[1]])
