import pandas as pd


def run(detail_path, set_path):
    data_set = pd.DataFrame()
    for detail_file in detail_path:
        data = pd.read_csv(detail_file)
        data_set = pd.concat(
            [data_set, data[["Set", "LncRNA", "Sub_Class", "Class"]]], ignore_index=True
        )
    data_set = data_set.groupby(["Set", "Sub_Class", "Class"]).agg(
        {"LncRNA": lambda x: ",".join(set(x.astype(str)))}
    )
    data_set.to_csv(set_path[0])


run(snakemake.input, snakemake.output)
